function love.load()
	lg = love.graphics
	lg.setLineStyle("smooth")
	love.keyboard.setKeyRepeat(false)
	--solving and simulating d2u/dt2 = c2 d2u/dx2
	--initializing number line
	x = {} --numberline
	bin = 5 --bin width in pixels
	steps = math.floor(lg.getWidth()/bin) --simulation width
	--steps = 5
	startval = 50
	left = 50 --boundary conditions
	right = 50

	x[1] = left
	x[steps+1] = right

	xs = {} --first spatial derivative
	startvals = 0
	lefts = 0
	rights = 0

	xs[1] = lefts
	xs[steps+1] = rights

	xss = {} --second spatial derivative
	startvalss = 0
	leftss = 0
	rightss = 0

	xss[1] = leftss
	xs[steps+1] = rightss

	xt = {} --first temporal derivative
	startvalt = 0
	leftt = 0
	rightt = 0

	xt[1] = leftt
	xt[steps+1] = rightt

	for i=2,steps do
		x[i] = startval
		xs[i] = startvals
		xss[i] = startvalss
		xt[i] = startvalt
	end
	x[math.floor(lg.getWidth()/(2*bin))] = 100 --placing a test peak in the middle

	c = 10

	down = math.floor(lg.getHeight()/2)

	function slope(a,i,d)
		--
		dy1 = a[i] - a[i+1]

		dy2 = a[i-1] - a[i]
		m1 = dy1/d
		m2 = dy2/d

		m = (m1+m2)/2

		return(m)
	end

end

function love.update(dt)
	for i=2,steps,1 do

		xs[i] = slope(x,i,bin)
		xss[i] = slope(xs,i,bin)
		xt[i] = xt[i] + c*c*xss[i]*dt
		x[i] = x[i] + xt[i] * dt
	end
	if love.keyboard.isDown("+") then
		c = c + 0.1
	end
	if love.keyboard.isDown("-") then
		c = c - 0.1
	end
end

function love.draw()
	lg.setColor(255,255,255)
	lg.line(0,down,bin*steps,down)
	lg.setColor(0,0,255)
	for i=1,steps+1,1 do
		local vert = {(i-1)*bin,down, (i-1)*bin,down-x[i], (i)*bin,down-x[i], (i)*bin,down}
		lg.polygon("fill", vert)
	end
end
